﻿Imports Windows.UI.ApplicationSettings
Imports Windows.UI.Popups
Imports Windows.System

' 空のアプリケーション テンプレートについては、http://go.microsoft.com/fwlink/?LinkId=234227 を参照してください

''' <summary>
''' 既定の Application クラスを補完するアプリケーション固有の動作を提供します。
''' </summary>
NotInheritable Class App
    Inherits Application

    ''' <summary>
    ''' アプリケーションがエンド ユーザーによって正常に起動されたときに呼び出されます。他のエントリ ポイントは、
    ''' アプリケーションが特定のファイルを開くために呼び出されたときに
    ''' 検索結果やその他の情報を表示するために使用されます。
    ''' </summary>
    ''' <param name="args">起動要求とプロセスの詳細を表示します。</param>
    Protected Overrides Sub OnLaunched(args As Windows.ApplicationModel.Activation.LaunchActivatedEventArgs)
        Dim rootFrame As Frame = Window.Current.Content
        SettinsgLoad()
        ' ウィンドウに既にコンテンツが表示されている場合は、アプリケーションの初期化を繰り返さずに、
        ' ウィンドウがアクティブであることだけを確認してください

        If rootFrame Is Nothing Then
            ' ナビゲーション コンテキストとして動作するフレームを作成し、最初のページに移動します
            rootFrame = New Frame()

            If args.PreviousExecutionState = ApplicationExecutionState.Terminated Then
                'TODO: 以前中断したアプリケーションから状態を読み込みます。
            End If
            ' フレームを現在のウィンドウに配置します
            Window.Current.Content = rootFrame
        End If
        If rootFrame.Content Is Nothing Then
            ' ナビゲーション スタックが復元されていない場合、最初のページに移動します。
            ' このとき、必要な情報をナビゲーション パラメーターとして渡して、新しいページを
            ' 構成します
            If Not rootFrame.Navigate(GetType(MainPage), args.Arguments) Then
                Throw New Exception("Failed to create initial page")
            End If
        End If

        ' 現在のウィンドウがアクティブであることを確認します
        Window.Current.Activate()

    End Sub

    ''' <summary>
    ''' アプリケーションの実行が中断されたときに呼び出されます。アプリケーションの状態は、
    ''' アプリケーションが終了されるのか、メモリの内容がそのままで再開されるのか
    ''' わからない状態で保存されます。
    ''' </summary>
    ''' <param name="sender">中断要求の送信元。</param>
    ''' <param name="e">中断要求の詳細。</param>
    Private Sub OnSuspending(sender As Object, e As SuspendingEventArgs) Handles Me.Suspending
        Dim deferral As SuspendingDeferral = e.SuspendingOperation.GetDeferral()
        ' TODO: アプリケーションの状態を保存してバックグラウンドの動作があれば停止します
        deferral.Complete()
    End Sub


    Const SID_About As String = "About"
    'Const SLB_About As String = "このアプリについて"
    Const PRIVACY_ABOUT As String = "プライバシーポリシー"

    Public Sub SettinsgLoad()
        AddHandler SettingsPane.GetForCurrentView().CommandsRequested, AddressOf onCommandsRequested
    End Sub

    Private Sub onCommandsRequested(mySettingsPane As SettingsPane, args As SettingsPaneCommandsRequestedEventArgs)
        If args.Request.ApplicationCommands.Count = 0 Then
            Dim handler As UICommandInvokedHandler = New UICommandInvokedHandler(AddressOf onSettingsCommand)
            'Dim aboutCommand As SettingsCommand = New SettingsCommand(SID_About, SLB_About, handler)
            'args.Request.ApplicationCommands.Add(aboutCommand)

            Dim PrivacyCommand As New SettingsCommand(PRIVACY_ABOUT, PRIVACY_ABOUT, handler)
            args.Request.ApplicationCommands.Add(PrivacyCommand)
        End If
    End Sub

    Private Sub onSettingsCommand(command As IUICommand)
        Dim mySettingsCommand As SettingsCommand = DirectCast(command, SettingsCommand)
        Select Case mySettingsCommand.Id.ToString
            'Case SID_About
            '    ShowAbout()
            '    Exit Select
            Case PRIVACY_ABOUT
                PrivacyPolicyShow()
                Exit Select
        End Select
    End Sub

    Private Sub ShowAbout()
        Dim _settingWidth As Double = 346
        Dim _popup As New Popup
        _popup.IsLightDismissEnabled = True
        _popup.Width = _settingWidth
        _popup.Height = Window.Current.Bounds.Height

        'Dim pane As AboutControl = New AboutControl
        'pane.Width = _settingWidth
        'pane.Height = Window.Current.Bounds.Height
        '_popup.Child = pane
        '_popup.SetValue(Canvas.LeftProperty, Window.Current.Bounds.Width - _settingWidth)
        '_popup.SetValue(Canvas.TopProperty, 0)
        '_popup.IsOpen = True
    End Sub

    Private Async Sub PrivacyPolicyShow()
        Dim myResult = Await Launcher.LaunchUriAsync(New Uri("http://2008r2.projectkyss.net/kuniyasu/privacypolicy.htm"))
    End Sub
End Class

